package mvcsSkeleton.views.mediators
{
	import mvcsSkeleton.controllers.events.BehavioursEvent;
	import mvcsSkeleton.controllers.events.LoggerEvent;
	import mvcsSkeleton.views.components.MorphogenView;
	
	import robotlegs.bender.bundles.mvcs.Mediator;
	
	public class MorphogenMediator extends Mediator
	{
		
		[Inject]
		public var view:MorphogenView;
		
		override public function initialize():void
		{
			//ADD LISTENRS FOR EVENTS FROM VIEW AND REDISPATCH THEM
			
			//MakeSquaresMediator listens for:
			addViewListener(BehavioursEvent.MAKE_SQUARE_REQUESTED, dispatch, BehavioursEvent);
			//MakeCirclesMediator listens for:
			addViewListener(BehavioursEvent.MAKE_CIRCLE_REQUESTED, dispatch, BehavioursEvent);
			
			//RotateShapesMediator listens for:
			addViewListener(BehavioursEvent.ROTATE_SHAPE_REQUESTED, dispatch, BehavioursEvent);
			
			//ResetShapesMediator listens for:
			addViewListener(BehavioursEvent.DELETE_ONE_SHAPE_REQUESTED, dispatch, BehavioursEvent);
			addViewListener(BehavioursEvent.DELETE_ALL_SHAPES_REQUESTED, dispatch, BehavioursEvent);		
			addViewListener(BehavioursEvent.RESET_SHAPE_ROTATION_REQUESTED, dispatch, BehavioursEvent);
			
			//LISTEN FOR EVENTS FROM OTHER MEDIATORS
			addContextListener(LoggerEvent.VIEW_STATE_CHANGED, onViewChanged, LoggerEvent);
		}
		
		private function onViewChanged(event:LoggerEvent):void
		{
			//writes the message to a text field
			view.addToLogger(event.payload);
		}
	}
}