package mvcsSkeleton.views.mediators
{
	import mvcsSkeleton.controllers.events.BehavioursEvent;
	import mvcsSkeleton.controllers.events.LoggerEvent;
	import mvcsSkeleton.views.api.IResetShapes;
	import mvcsSkeleton.views.api.IRotateShapes;

	import robotlegs.bender.bundles.mvcs.Mediator;

	public class ResetShapesMediator extends Mediator
	{
		[Inject]
		public var view:IResetShapes;

		override public function initialize():void
		{
			trace("ResetShapesMediator.initialize()");
			addContextListener(BehavioursEvent.RESET_SHAPE_ROTATION_REQUESTED, onResetShapeRotation, BehavioursEvent);
			addContextListener(BehavioursEvent.DELETE_ONE_SHAPE_REQUESTED, onDeleteShape, BehavioursEvent);
			addContextListener(BehavioursEvent.DELETE_ALL_SHAPES_REQUESTED, onDeleteAllShapes, BehavioursEvent);

			//addViewListener(LoggerEvent.VIEW_STATE_CHANGED, dispatch, LoggerEvent);
		}
		//view == views implementing IRotateShapes (all 3 in this example: MonomorphicViewOne, MonomorphicViewTwo, PolymorphicView)
		private function onResetShapeRotation(event:BehavioursEvent):void
		{
			view.resetShapeRotation();
		}

		private function onDeleteShape(event:BehavioursEvent):void
		{
			view.deleteShape(String(event.payload));
		}

		private function onDeleteAllShapes(event:BehavioursEvent):void
		{
			view.deleteAllShapes();
		}
	}
}
